import org.jetbrains.kotlin.gradle.tasks.KotlinCompile

plugins {
	kotlin("jvm") version "1.3.50"
	idea
	id("fabric-loom") version "0.2.5-SNAPSHOT"
}

java {
	sourceCompatibility = JavaVersion.VERSION_1_8
	targetCompatibility = JavaVersion.VERSION_1_8
}

base {
	archivesBaseName = "AutoSwap"
}

group = "net.shadowfacts"
version = "0.1.0"

val minecraftVersion = "1.14.4"
val yarnMappings = "1.14.4+build.9"
val loaderVersion = "0.6.3+build.167"
val fabricVersion = "0.4.0+build.240-1.14"
val fabricKotlinVersion = "1.3.50+build.3"

minecraft {
}

repositories {
	maven(url = "https://maven.fabricmc.net") {
		name = "Fabric"
	}
	maven(url = "https://kotlin.bintray.com/kotlinx")
	jcenter()
}

dependencies {
	minecraft(group = "com.mojang", name = "minecraft", version = minecraftVersion)
	mappings(group = "net.fabricmc", name = "yarn", version = yarnMappings)

	modImplementation(group = "net.fabricmc", name = "fabric-loader", version = loaderVersion)
	modImplementation(group = "net.fabricmc.fabric-api", name = "fabric-api", version = fabricVersion)

	modImplementation(group = "net.fabricmc", name = "fabric-language-kotlin", version = fabricKotlinVersion)
}

tasks.getByName<ProcessResources>("processResources") {
	filesMatching("fabric.mod.json") {
		expand(
			mutableMapOf(
				"version" to project.version
			)
		)
	}
}

tasks.withType<KotlinCompile>().configureEach {
	kotlinOptions {
		jvmTarget = "1.8"
	}
}